## jzmq 3.1.0

=== CMakeLists.txt ===
# CMake build script for ØMQ Java bindings on Windows

cmake_minimum_required (VERSION 2.8)

project (JZMQ)
find_package (Java REQUIRED)
find_package (JNI REQUIRED)

find_program (JNI_JAVAH
  NAMES javah
	HINTS ${_JAVA_HINTS}
	PATHS ${_JAVA_PATHS}
)

#-----------------------------------------------------------------------------
# force off-tree build


if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
message(FATAL_ERROR "CMake generation is not allowed within the source directory!
Remove the CMakeCache.txt file and try again from another folder, e.g.:

   del CMakeCache.txt
   mkdir build
   cd build
   cmake ..
")
endif(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

#-----------------------------------------------------------------------------
# default to Release build

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/lib)

#-----------------------------------------------------------------------------
# platform specifics

add_definitions(
        -DWIN32
	-DDLL_EXPORT
	-DFD_SETSIZE=1024
)

#-----------------------------------------------------------------------------
# source files

set(java-sources
	org/zeromq/ZMQ.java
	org/zeromq/ZMQException.java
	org/zeromq/ZMQForwarder.java
	org/zeromq/ZMQQueue.java
	org/zeromq/ZMQStreamer.java
	org/zeromq/EmbeddedLibraryTools.java
	org/zeromq/App.java
	org/zeromq/ZContext.java
	org/zeromq/ZDispatcher.java
	org/zeromq/ZFrame.java
	org/zeromq/ZMsg.java
	org/zeromq/ZLoop.java
	org/zeromq/ZThread.java
)
set(java-classes
	org/zeromq/ZMQ.class
	org/zeromq/ZMQ$$Context.class
	org/zeromq/ZMQ$$Socket.class
	org/zeromq/ZMQ$$PollItem.class
	org/zeromq/ZMQ$$Poller.class
	org/zeromq/ZMQ$$Error.class				
	org/zeromq/ZMQException.class
	org/zeromq/ZMQQueue.class
	org/zeromq/ZMQForwarder.class
	org/zeromq/ZMQStreamer.class
	org/zeromq/EmbeddedLibraryTools.class
	org/zeromq/App.class
	org/zeromq/ZContext.class
	org/zeromq/ZDispatcher.class
	org/zeromq/ZDispatcher$$1.class
	org/zeromq/ZDispatcher$$SocketDispatcher$$1.class
	org/zeromq/ZDispatcher$$SocketDispatcher$$2.class
	org/zeromq/ZDispatcher$$SocketDispatcher$$ZMessageBuffer.class
	org/zeromq/ZDispatcher$$SocketDispatcher.class
	org/zeromq/ZDispatcher$$ZMessageHandler.class
	org/zeromq/ZDispatcher$$ZSender.class
	org/zeromq/ZFrame.class
	org/zeromq/ZMsg.class
	org/zeromq/ZLoop.class
	org/zeromq/ZLoop$$IZLoopHandler.class
	org/zeromq/ZLoop$$SPoller.class
	org/zeromq/ZLoop$$STimer.class
	org/zeromq/ZThread.class
	org/zeromq/ZThread$$IAttachedRunnable.class
	org/zeromq/ZThread$$IDetachedRunnable.class
	org/zeromq/ZThread$$ShimThread.class
)
set(javah-headers
	org_zeromq_ZMQ.h
	org_zeromq_ZMQ_Error.h
	org_zeromq_ZMQ_Context.h
	org_zeromq_ZMQ_Socket.h
	org_zeromq_ZMQ_PollItem.h
	org_zeromq_ZMQ_Poller.h	
)
set(cxx-sources
	Context.cpp
	Poller.cpp
	Socket.cpp
	util.cpp
	ZMQ.cpp
)

include_directories(
        src
        src/main/java
	${CMAKE_CURRENT_BINARY_DIR}
)

#-----------------------------------------------------------------------------
# optional modules

add_definitions(
	-DZMQ_HAVE_OPENPGM
)
include_directories(
#	/zeromq/zeromq-2.1.10/include
#	c:/zeromq/zeromq-3.3.0/include
	c:/zeromq/zeromq-3.2.2/include
	${JNI_INCLUDE_DIRS}
)
link_directories(
#	/zeromq/zeromq-2.1.10/build/lib
#	/zeromq/zeromq-2.1.10/build64/lib
#	c:/zeromq/zeromq-3.3.0/lib
	c:/zeromq/zeromq-3.2.2/lib
)

#-----------------------------------------------------------------------------
# source generators

foreach (source ${cxx-sources})
	list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/src/main/c++/${source})	
endforeach()

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/config.hpp
	COMMAND ${CMAKE_COMMAND}
	ARGS	-E
		copy
		${CMAKE_CURRENT_SOURCE_DIR}/builds/msvc/config.hpp
		${CMAKE_CURRENT_BINARY_DIR}/config.hpp
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/builds/msvc/config.hpp
)
list(APPEND sources ${CMAKE_CURRENT_BINARY_DIR}/config.hpp)

add_custom_command(
	OUTPUT ${javah-headers}
	COMMAND ${JNI_JAVAH}
	ARGS	-jni
		-classpath ${CMAKE_CURRENT_BINARY_DIR}
		org.zeromq.ZMQ
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	DEPENDS ${java-classes}
)
list(APPEND sources ${javah-headers})

set (source-tmp "")
foreach (source ${java-sources})
	list (APPEND source-tmp ${CMAKE_CURRENT_SOURCE_DIR}/src/main/java/${source})
endforeach()
set (java-sources ${source-tmp})

add_custom_command(
	OUTPUT ${java-classes}
	COMMAND ${JAVA_COMPILE}
	ARGS	-classpath ${CMAKE_CURRENT_BINARY_DIR}
		-sourcepath ${CMAKE_CURRENT_SOURCE_DIR}/src/main/java
		-d ${CMAKE_CURRENT_BINARY_DIR}
		${java-sources}
	DEPENDS ${java-sources}
)

add_custom_command(
	OUTPUT lib/zmq.jar
	COMMAND ${JAVA_ARCHIVE}
	ARGS	cf
		lib/zmq.jar
		${java-classes}
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	DEPENDS ${java-classes}
)
list(APPEND sources lib/zmq.jar)

#-----------------------------------------------------------------------------
# output

add_library(jzmq SHARED ${sources})
target_link_libraries(jzmq libzmq.lib)

set(docs
        AUTHORS
	COPYING
	COPYING.LESSER
	ChangeLog
	INSTALL
	NEWS
	README
	README-PERF
)

install (TARGETS jzmq DESTINATION lib)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/lib/zmq.jar DESTINATION lib)
install (FILES ${docs} DESTINATION doc)

# By default, do not warn when built on machines using only VS Express:
IF(NOT DEFINED CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS)
	SET(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)
ENDIF()

include (InstallRequiredSystemLibraries)
set (CPACK_PACKAGE_VENDOR "Miru Limited")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
#set (CPACK_PACKAGE_VERSION_MAJOR "2")
#set (CPACK_PACKAGE_VERSION_MINOR "1")
#set (CPACK_PACKAGE_VERSION_PATCH "10")
set (CPACK_PACKAGE_VERSION_MAJOR "3")
set (CPACK_PACKAGE_VERSION_MINOR "2")
set (CPACK_PACKAGE_VERSION_PATCH "2")
include (CPack)

# end of file

=== debian/changelog ===
jzmq (3.1.0-16ubuntu1) noble; urgency=medium

  * d/rules: use java_compat_level variable provided by java-common to
    adjust -source/-target level to the minimum required by the default
    Java (LP: #2052991).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 13 Feb 2024 16:31:51 +1300

jzmq (3.1.0-16) unstable; urgency=medium

  * Add dependency on cppzmq-dev to fix broken build caused by
    change in zeromq3 (in fix for #972785). 
    (Closes: #1020047)

 -- Jan Niehusmann <jan@debian.org>  Tue, 27 Sep 2022 18:59:17 +0200

jzmq (3.1.0-15) unstable; urgency=medium

  * Set source and target version to 1.7 (Closes: Bug#981991)

 -- Jan Niehusmann <jan@debian.org>  Fri, 05 Feb 2021 23:13:17 +0100

jzmq (3.1.0-14) unstable; urgency=medium

  * Use "javac -h" instead of javah, as javah doesn't exist with java 10
    (Requires at least java 8)

 -- Jan Niehusmann <jan@debian.org>  Fri, 04 May 2018 21:18:44 +0200

jzmq (3.1.0-13) unstable; urgency=medium

  * Add watch file
  * Depend on headless jdk
  * Depend on junit4 (Closes: Bug#897470)
  * Set source and target version to 1.6

 -- Jan Niehusmann <jan@debian.org>  Wed, 02 May 2018 23:36:45 +0200

jzmq (3.1.0-12) unstable; urgency=medium

  * Point Vcs-Git and Vcs-Browser URLs to salsa.debian.org
  * Work around #887666 by removing -N option from call to jh_linkjars
  * Set classpath in call to javadoc (Closes: Bug#875592)
    Thanks to Emmanuel Bourg for providing the patch

 -- Jan Niehusmann <jan@debian.org>  Sat, 10 Mar 2018 12:22:28 +0100

jzmq (3.1.0-10) unstable; urgency=medium

  * Apply patch by Steven Chamberlain to fix build on kfreebsd
    (Closes: Bug#816556)

 -- Jan Niehusmann <jan@debian.org>  Thu, 03 Mar 2016 16:22:20 +0100

jzmq (3.1.0-9) unstable; urgency=medium

  * Upgrade dependency to libzmq5
  * Add a missing include which is necessary with the new version
    of libzmq5. Fixed by Laszlo Boszormenyi. (Closes: Bug#815942)

 -- Jan Niehusmann <jan@debian.org>  Mon, 29 Feb 2016 23:37:59 +0100

jzmq (3.1.0-8) unstable; urgency=medium

  * Remove space after option -S in call to dh from debian/rules.
    The additional space seems to break "dh binary-indep", but doesn't
    hurt for "dh binary".
    (Closes: Bug#805944)
  * Only build javadocs for build-indep target

 -- Jan Niehusmann <jan@debian.org>  Tue, 24 Nov 2015 15:33:13 +0100

jzmq (3.1.0-7) unstable; urgency=medium

  * Fix package description. (Closes: Bug#802856)

 -- Jan Niehusmann <jan@debian.org>  Sat, 24 Oct 2015 13:35:12 +0200

jzmq (3.1.0-6) unstable; urgency=medium

  * Place native library in separate binary package, libzmq-jni.
    (Closes: Bug#802276)
  * Make libzmq-jni 'Multi-Arch: same'

 -- Jan Niehusmann <jan@debian.org>  Wed, 21 Oct 2015 18:37:47 +0200

jzmq (3.1.0-5) unstable; urgency=medium

  * Use javahelper with jh_maven_repo_helper (Closes: Bug#802278)

 -- Jan Niehusmann <jan@debian.org>  Wed, 21 Oct 2015 17:02:39 +0200

jzmq (3.1.0-4) unstable; urgency=medium

  * Set locale to en_US when generating javadoc, to make the builds
    reproducible.

 -- Jan Niehusmann <jan@debian.org>  Fri, 10 Jul 2015 09:43:42 +0200

jzmq (3.1.0-3) unstable; urgency=low

  * Fix versioned dependency on default-jdk (epoch was missing)
  * Add Vcs-Git header

 -- Jan Niehusmann <jan@debian.org>  Thu, 22 Jan 2015 11:19:26 +0100

jzmq (3.1.0-2) unstable; urgency=low

  * Build-depend on default-jdk (>= 1.6) | openjdk-6-jdk | java-6-sdk,
    to make sure some jdk-6 is used to build the package.
    (This hopefully fixes builds on kfreebsd and sparc)
  * Add (jzmq) to the package description, so it can be found by
    searching for 'jzmq' (which is the name used by upstream)

 -- Jan Niehusmann <jan@debian.org>  Wed, 21 Jan 2015 20:28:18 +0100

jzmq (3.1.0-1) unstable; urgency=low

  * New packaging of jzmq
    (The existing contents of debian/ from upstream were
    completely outdated, so I started from scratch.
    (Closes: Bug#774985)
  * Cherry-Picked commit c08f892 by J.T. Conklin from upstream to
    pass $(JAVACFLAGS) to $(JAVAC) invocations.

 -- Jan Niehusmann <jan@debian.org>  Sun, 18 Jan 2015 21:47:00 +0100

=== debian/control ===
Source: jzmq
Section: java
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jan Niehusmann <jan@debian.org>
Build-Depends: debhelper (>= 9), dh-exec (>=0.3), libzmq5-dev, default-jdk-headless (>= 2:1.8) | openjdk-8-jdk-headless | java-8-sdk-headless, libpgm-dev, pkg-config, libtool, autoconf, libtool-bin, automake, maven-repo-helper, javahelper, dh-autoreconf, default-jdk-doc, junit4, cppzmq-dev
Standards-Version: 3.9.6
Homepage: https://github.com/zeromq/jzmq
Vcs-Git: https://salsa.debian.org/jan/jzmq.git
Vcs-Browser: https://salsa.debian.org/jan/jzmq

Package: libzmq-java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${java:Recommends}, libzmq-jni (= ${binary:Version})
Description: ZeroMQ Java bindings (jzmq)
 ZeroMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ZeroMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains JNI-based Java bindings for ZeroMQ.

Package: libzmq-jni
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${java:Recommends}
Pre-Depends: ${misc:Pre-Depends}
Description: ZeroMQ Java bindings (jzmq)
 ZeroMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ZeroMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains JNI libraries for libzmq-java.

Package: libzmq-java-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${java:Recommends}
Description: Documentation for ZeroMQ Java bindings (jzmq)
 ZeroMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ZeroMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains JavaDoc documentation for the Java bindings for ZeroMQ.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/java/java_defaults.mk

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export JAVACFLAGS = -source $(java_compat_level) -target $(java_compat_level)

JAVA_HOME=/usr/lib/jvm/default-java

%:
	dh $@ --with javahelper --with jh_maven_repo_helper -Sautoconf --with autoreconf

build-indep:
	javadoc -locale en_US -d debian/build/javadoc -classpath /usr/share/java/junit4.jar -link /usr/share/doc/default-jdk-doc/api $(shell find -name "*.java")

# work around #887666
override_jh_linkjars:
	jh_linkjars -O-Sautoconf

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/jzmq-$1\.tar\.gz/ \
  https://github.com/zeromq/jzmq/tags .*/v?(\d\S+)\.tar\.gz
